package com.xkrs.microservice.service;

import com.xkrs.microservice.model.entity.TeaGardenPlotEntity;
import com.xkrs.microservice.model.qo.TeaGardenPlotQo;

import java.util.Optional;


/**
 * 茶园地块服务管理接口
 * @author tajochen
 */
public interface TeaGardenPlotService {

    /**
     * 获取所有典型地块记录
     * @return
     */
    Iterable<TeaGardenPlotEntity> getAllRecord();

    /**
     * 获取所有典型地块记录根据编号
     * @param id 编号
     * @return
     */
    Optional<TeaGardenPlotEntity> getAllRecordById(Integer id);

    /**
     * 获取指定地块编号记录
     * @param dkbh
     * @return
     */
    TeaGardenPlotEntity getAllRecordByDkbh(String dkbh);

    /**
     * 获取指定地块根据状态
     * @param status
     * @return
     */
    Iterable<TeaGardenPlotEntity> getAllRecordByStatus(Integer status);


    /**
     * 新增典型地块记录
     * @param teaGardenPlotQo
     */
    void add(TeaGardenPlotQo teaGardenPlotQo);

    /**
     * 更新典型地块记录
     * @param teaGardenPlotQo
     */
    void update(TeaGardenPlotQo teaGardenPlotQo);

    /**
     * 删除典型地块记录
     * @param id
     * @return
     */
    int delete(Integer id);

}
